;;; $Id: helpers.scm 98 2005-12-16 19:52:45Z rlpm $

;;; Scheme helper functions
;;; Author: Rory McGuire <rlpm at cs dot unm dot edu>

;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License as
;;; published by the Free Software Foundation; either version 2 of the
;;; License, or (at your option) any later version.
     
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; General Public License for more details.

;;; You can obtain a copy of the GPL at:
;;;   http://www.fsf.org/copyleft/gpl.html.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (iota n)
  (letrec ((loop (lambda (n acc)
                   (if (= n 0)
                       acc
                       (loop (- n 1) (cons n acc))))))
    (loop n ())))

(define (iota0 n)
  (map sub1 (iota n)))

(define (filter pred ls)
  (define (loop ls acc)
    (if (null? ls)
        acc
        (loop (cdr ls)
              (if (pred (car ls))
                  (cons (car ls) acc)
                  acc))))
  (reverse (loop ls ())))

(define (o f . rest)
  (if (null? rest)
      f
      (apply o (lambda (x) (f ((car rest) x))) (cdr rest))))

(define (select pred ls1 ls2)
  (map cdr (filter (o pred car) (map cons ls1 ls2))))

(define (iterate f n)
  (apply o (map (lambda (x) f) (iota n))))

(define (list-all f)
  (lambda (ls) (null? (filter (o not f) ls))))

(define (list-all-true ls)
  ((list-all (lambda(x)x)) ls))
